var { MailServices } = ChromeUtils.import("resource:///modules/MailServices.jsm");
var { MailUtils } = ChromeUtils.import("resource:///modules/MailUtils.jsm");
var { Services } = ChromeUtils.import("resource://gre/modules/Services.jsm");
var { XPCOMUtils } = ChromeUtils.import("resource://gre/modules/XPCOMUtils.jsm");
XPCOMUtils.defineLazyModuleGetters(this, {
  appIdleManager: "resource:///modules/AppIdleManager.jsm",
  Gloda: "resource:///modules/gloda/GlodaPublic.jsm",
  MailE10SUtils: "resource:///modules/MailE10SUtils.jsm",
});

XPCOMUtils.defineLazyScriptGetter(
  this,
  "PrintUtils",
  "chrome://messenger/content/printUtils.js"
);



var printOpener;
var pdfFile;
var msgPane;
var uriArray;
var sourceBrowsingContext;
var wasCanceled;
var dialogText;

function OnLoad()
{
    InitPrintEngineWindow();
    
    addEventListener('close', (event) => {
        console.log("Dialog closed.");
        console.log(document.getElementById('print-window'));
        console.log(document.getElementById('dialog-progressText'));
        
    });
    
    
    document.getElementById("dmsTitle").innerHTML = dialogText;
    document.getElementById("printEngineWin").title = "Hello World";
   

    
/*    var nMessages = top.opener.gFolderDisplay.selectedMessages;
    const mailSessionContractID = "@mozilla.org/messenger/services/session;1";
    const nsIMsgMailSession = Components.interfaces.nsIMsgMailSession;
    var mailSession = Components.classes[mailSessionContractID].getService(nsIMsgMailSession);
    var url = mailSession.ConvertMsgURIToMsgURL( uriArray[0] ,  msgWindow );
    
    console.log("url: "+url);
*/  

    console.log(msgPane);
    wasCanceled=true;
    sourceBrowsingContext = msgPane.browsingContext;
    var printSettings = PrintUtils.getPrintSettings();
    console.log(printSettings);
    /*printSettings.toFileName = pdfFile;
    printSettings.printBGColors = true;
    printSettings.printBGImages = true;
    printSettings.printerName = 'Print to File';
    printSettings.printToFile = true;
    printSettings.isInitializedFromPrefs = true;
    printSettings.isInitializedFromPrinter = true;*/
	
	
  printSettings.printSilent=true;
  printSettings.printToFile=true;
  printSettings.toFileName=pdfFile;
  printSettings.outputFormat=Components.interfaces.nsIPrintSettings.kOutputFormatPDF;
  printSettings.printBGImages = true;
  printSettings.showPrintProgress = true;
  printSettings.printBGColors = true;
  printSettings.footerStrCenter = "";
  printSettings.footerStrLeft="";
  printSettings.footerStrRight="";
  printSettings.headerStrCenter = "";
  printSettings.headerStrLeft="";
  printSettings.headerStrRight="";
  printSettings.shrinkToFit=true;
	
    PrintUtils.printWindow(sourceBrowsingContext,printSettings).then(function()
    {
        wasCanceled=false;
        window.close();
    });
    console.log(sourceBrowsingContext);

    
}

function InitPrintEngineWindow()
{
  /* Store the current opener for later access in ReplaceWithSelection() */
  printOpener = opener;

  
  if ( window.arguments && window.arguments[0] != null )
  {
    var numSelected = window.arguments[0];
    uriArray = window.arguments[1];
    pdfFile=window.arguments[2];
    msgPane = window.arguments[3];
    dialogText = window.arguments[4];
 
  }
}
