var { ExtensionCommon } = ChromeUtils.import("resource://gre/modules/ExtensionCommon.jsm");
var { Services } = ChromeUtils.import("resource://gre/modules/Services.jsm");
var { FileUtils } = ChromeUtils.import("resource://gre/modules/FileUtils.jsm");
var { MailUtils } = ChromeUtils.import("resource:///modules/MailUtils.jsm");
var { XPCOMUtils } = ChromeUtils.import(
  "resource://gre/modules/XPCOMUtils.jsm"
);



var currentMsg;
var uris;
var emailFile;
var pdfFile;
var pPath = null;
var mySubject = null;
var myDate = new Date();
var composeListener;
var ecodmsapi = null; 
var m_tabbedBrowser = null;
var isSendMail=false;

function ecoDMS_getWorkerPath()
{

                try
                {
                    if (pPath!=null)
                        return pPath;
                    else
                    {
                        var xulruntime=Components.classes["@mozilla.org/xre/app-info;1"]
                            .getService(Components.interfaces.nsIXULRuntime);

                        if(xulruntime.OS=="WINNT")
                        {
                            var wrk = Components.classes["@mozilla.org/windows-registry-key;1"]
                                                    .createInstance(Components.interfaces.nsIWindowsRegKey);

                            var printcomworkerpath=null;
                            wrk.open(wrk.ROOT_KEY_LOCAL_MACHINE,"SOFTWARE",wrk.ACCESS_READ);
                            if (wrk.hasChild("applord gmbh\\ecoDMS Printer"))
                            {
                                var subkey = wrk.openChild("applord gmbh\\ecoDMS Printer", wrk.ACCESS_READ);
                                printcomworkerpath= subkey.readStringValue("InstallPath");
                                subkey.close();
                            }
                            wrk.close();
                            if (printcomworkerpath===null)
                            {
                                wrk.open(wrk.ROOT_KEY_LOCAL_MACHINE,"SOFTWARE",wrk.ACCESS_READ);
                                if (wrk.hasChild("WOW6432Node\\applord gmbh\\ecoDMS Printer"))
                                {
                                    var subkey = wrk.openChild("WOW6432Node\\applord gmbh\\ecoDMS Printer", wrk.ACCESS_READ);
                                    printcomworkerpath= subkey.readStringValue("InstallPath");
                                    subkey.close();
                                }
                                wrk.close();
                            }

                            if (printcomworkerpath!==null)
                            {
                            printcomworkerpath=printcomworkerpath.replace("\"","");
                            printcomworkerpath=printcomworkerpath.replace("\"","");
                            printcomworkerpath=printcomworkerpath+"\\printcomworker.exe";
                            }
                            pPath=printcomworkerpath;
                            return printcomworkerpath;
                        }
                        else if (xulruntime.OS=="Darwin")
                        {
                            pPath="/Applications/ecoDMS Client.app/Contents/MacOS/printcomworker";
                            return pPath;
                        }
                        else
                        {
                            pPath="/opt/ecodms/ecodmsclient/printcomworker";
                            return pPath;
                        }
                    }
                }
                catch(err)
                {
                    return null;
                }
};

function ecoDMS_doSaveToArchive()
{
                console.log("Do save to archive.");
                
                if (m_tabbedBrowser!=null)
                    m_tabbedBrowser.removeCurrentTab();
                
                var executable = Components.classes["@mozilla.org/file/local;1"]
                                                    .createInstance(Components.interfaces.nsIFile);
                var process = Components.classes["@mozilla.org/process/util;1"]
                                                    .createInstance(Components.interfaces.nsIProcess);
                var printcomworkerpath = ecoDMS_getWorkerPath();

                if (printcomworkerpath==null)
                {
                    alert('Die E-Mail kann nicht archiviert werden, installieren sie den ecoDMS Printer!');
                    return;
                }


                if (printcomworkerpath=="/opt/ecodms/ecodmsclient/printcomworker")
                {
                    var env = Components.classes["@mozilla.org/process/environment;1"]
                                                    .getService(Components.interfaces.nsIEnvironment);
                    env.set("LD_LIBRARY_PATH","/opt/ecodms/ecodmsclient/");
                }

                executable.initWithPath(printcomworkerpath);
                process.init(executable);
                var tsubject = unescape(encodeURIComponent(mySubject));
                tsubject = tsubject.replace(/#/g,'-');
                
                if (tsubject.length>255)
                    tsubject = tsubject.substr(0,255);
                
                
                let recentWindow = Services.wm.getMostRecentWindow("mail:3pane");
                //Mit datum: var args = new Array("-f",pdfFile.path,"-o",emailFile.path,"-p",btoa("0##"+tsubject+"######"+myDate.yyyymmdd()+"#"));
                var args = new Array("-f",pdfFile.path,"-o",emailFile.path,"-p",recentWindow.btoa("0##"+tsubject+"#"));
                var argscount=6;
                
                if (printcomworkerpath=="/Applications/ecoDMS Client.app/Contents/MacOS/printcomworker")
                {
                    args = new Array("-f",emailFile.path,"-pn",recentWindow.btoa("0##"+tsubject+"#"));
                    argscount=4;
                }
                
                process.runAsync(args,argscount,function(subject,topic,data){
                    emailFile.remove(true);
                    emailFile=null;
                    pdfFile.remove(true);
                    pdfFile=null;
                    mySubject=null;
                    myDate = new Date();
                    currentMsg=currentMsg+1;
                    if(uris[currentMsg])
                        ecoDMS_doArchive(currentMsg);

                });
                
                
        };
        

function ecoDMS_onArchiveCommandWithSubject(msgUris,theSubject)
{
        mySubject=theSubject;
        currentMsg=0;
        uris=msgUris;
        ecoDMS_doArchive(currentMsg);
}

async function ecoDMS_doArchive(msgId)
{
     var version = await listener.sendNotification("version","");
     version = version.split(".")[0];
     if (version<=78)
     {
         ecoDMS_doArchive78(msgId);
     }
     else
         ecoDMS_doArchive91(msgId);
}

function ecoDMS_doArchive78(msgId)
{
                currentMsg=msgId;
                let recentWindow = Services.wm.getMostRecentWindow("mail:3pane");
                myDate = new Date();
                var printcomworkerpath = ecoDMS_getWorkerPath();
                var mymessenger = Components.classes["@mozilla.org/messenger;1"]
                                    .createInstance(Components.interfaces.nsIMessenger);

                    

                if (mySubject==null)
                {
                    try
                    {
                            mySubject = mymessenger.messageServiceFromURI(uris[msgId])
                                                .messageURIToMsgHdr(uris[msgId])
                                                .mime2DecodedSubject;
                                        
                            var theDate = mymessenger.messageServiceFromURI(uris[msgId])
                                                .messageURIToMsgHdr(uris[msgId])
                                                .date;
                                    
                            myDate = new Date(theDate/1000);
                            
                    }
                    catch (e)
                    {
                            mySubject="";
                    }
                }
                
                if (mySubject=="")
                    mySubject="EMail";
                
                
                var fileTemplate = recentWindow.GenerateValidFilename("E-Mail"+msgId,".eml");
                emailFile = FileUtils.getFile("TmpD",[fileTemplate]);
                emailFile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, FileUtils.PERMS_FILE);
                emailFile.remove(false);
                fileTemplate = recentWindow.GenerateValidFilename("E-Mail"+msgId,".pdf");
                pdfFile = FileUtils.getFile("TmpD",[fileTemplate]);
                pdfFile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, FileUtils.PERMS_FILE);
                pdfFile.remove(false);

                
                mymessenger.saveAs(uris[msgId],true,null,emailFile.path,true);

                var mySelection = new Array(1);
                mySelection[0] = uris[msgId];
                
                if (printcomworkerpath!=="/Applications/ecoDMS Client.app/Contents/MacOS/printcomworker")
                {
                        let printEngineWindow = recentWindow.openDialog("chrome://ecodms/content/mymsgPrintEngine.xhtml", "", "chrome,dialog=no,all,centerscreen", 1,mySelection,pdfFile.path);
                        printEngineWindow.addEventListener("DOMWindowClose",ecoDMS_doSaveToArchive,false);
                }
                else
                 {
                    ecoDMS_doSaveToArchive();
                }
};

        
async function ecoDMS_doArchive91(msgId)
{
    
                var version = await listener.sendNotification("version","");
                
                version = version.split(".")[0];
                
                console.log("Version: "+version);
                

                currentMsg=msgId;
                let recentWindow = Services.wm.getMostRecentWindow("mail:3pane");
               
                myDate = new Date();
                var printcomworkerpath = ecoDMS_getWorkerPath();
                var mymessenger = Components.classes["@mozilla.org/messenger;1"]
                                    .createInstance(Components.interfaces.nsIMessenger);
                 
               
                if (uris.length>1 || isSendMail)
                {
                    console.log("Open: "+uris[msgId]);
                    var m_msgHdr = mymessenger.messageServiceFromURI(uris[msgId])
                                                    .messageURIToMsgHdr(uris[msgId]);
                    
                    m_tabbedBrowser = recentWindow.document.getElementById("tabmail");
                    await m_tabbedBrowser.openTab("message", {
                        msgHdr: m_msgHdr,
                        background: false,
                    });
                }
                else
                    m_tabbedBrowser = null;
                
               

                isSendMail=false;
                    

                if (mySubject==null)
                {
                    try
                    {
                            mySubject = mymessenger.messageServiceFromURI(uris[msgId])
                                                .messageURIToMsgHdr(uris[msgId])
                                                .mime2DecodedSubject;
                                        
                            var theDate = mymessenger.messageServiceFromURI(uris[msgId])
                                                .messageURIToMsgHdr(uris[msgId])
                                                .date;
                                    
                            myDate = new Date(theDate/1000);
                            
                    }
                    catch (e)
                    {
                            mySubject="";
                    }
                }
                
                if (mySubject=="")
                    mySubject="EMail";
                
                
                var fileTemplate = recentWindow.GenerateValidFilename("E-Mail"+msgId,".eml");
                emailFile = FileUtils.getFile("TmpD",[fileTemplate]);
                emailFile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, FileUtils.PERMS_FILE);
                emailFile.remove(false);
                fileTemplate = recentWindow.GenerateValidFilename("E-Mail"+msgId,".pdf");
                pdfFile = FileUtils.getFile("TmpD",[fileTemplate]);
                pdfFile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, FileUtils.PERMS_FILE);
                pdfFile.remove(false);

                
                mymessenger.saveAs(uris[msgId],true,null,emailFile.path,true);

                var mySelection = new Array(1);
                mySelection[0] = uris[msgId];
                
                if (printcomworkerpath!=="/Applications/ecoDMS Client.app/Contents/MacOS/printcomworker")
                {
                        var dialogText = await listener.sendNotification("translate","saveToDMS");
                        let messagePaneBrowser = recentWindow.document.getElementById("messagepane");
                        let printEngineWindow = recentWindow.openDialog("chrome://ecodms/content/mymsgPrintEngine2.xhtml", "", "chrome,dialog=no,centerscreen", 1,mySelection,pdfFile.path,messagePaneBrowser,dialogText);
                        printEngineWindow.addEventListener("DOMWindowClose",ecoDMS_doSaveToArchive,false);
                }
                else
                 {
                    ecoDMS_doSaveToArchive();
                }
};

function ecoDMS_removeAttachmentContextMenus() {
    
    console.log("ecoDMS_removeAttachmentContextMenus");
    let recentWindow = Services.wm.getMostRecentWindow("mail:3pane");
    
    let action = recentWindow.document.getElementById("context-ecodms-saveattachment");
    if (action!=null)
        action.remove();

    action = recentWindow.document.getElementById("context-ecodms-listsaveattachment");
    if (action!=null)
        action.remove();

    action = recentWindow.document.getElementById("context-ecodms-menulistsaveattachment");
    if (action!=null)
        action.remove();
    
    action = recentWindow.document.getElementById("context-ecodms-menulistsaveallattachment");
    if (action!=null)
        action.remove();
    
};

function doArchiveAttachment()
{
    ecoDMS_doArchiveAttachment(0,false);
}

function doArchiveAllAttachments()
{
    ecoDMS_doArchiveAttachment(0,true);
}

function ecoDMS_checkAttachmentContextMenus(context) {
          console.log("checkAttachmentContextMenus");
          
          
          let recentWindow = Services.wm.getMostRecentWindow("mail:3pane");
          if (recentWindow)
          {
              console.log("Got window.");
              var attContext = recentWindow.document.getElementById("attachmentItemContext");
              if (attContext != null)
              {
                         
                  if (recentWindow.document.getElementById("context-ecodms-saveattachment")==null)
                  {
                  
                    var openAttachment = recentWindow.document.getElementById("context-openAttachment");
                    var ecodmsSaveAttachment = openAttachment.cloneNode(true);
                    ecodmsSaveAttachment.setAttribute("id","context-ecodms-saveattachment");
                    ecodmsSaveAttachment.setAttribute("oncommand","event.stopPropagation();");
                    ecodmsSaveAttachment.setAttribute("label",context.extension.localeData.localizeMessage("attachmentToDms"));
                    ecodmsSaveAttachment.setAttribute("accesskey","");
                    ecodmsSaveAttachment.addEventListener("click",doArchiveAttachment,false);
                    
                    attContext.appendChild(ecodmsSaveAttachment);
                    console.log("Attachment menu modified.");
                    
                  }
                  else
                  {
                      console.log("Attachment menu already modified.");
                  }
              }
              else
                console.log("Not found.");
              
              var allAttContext = recentWindow.document.getElementById("attachmentListContext");
              if (allAttContext != null)
              {
         
                  
                  if (recentWindow.document.getElementById("context-ecodms-listsaveattachment")==null)
                  {
                  
                    var allOpenAttachment = recentWindow.document.getElementById("context-openAllAttachments");
                    
                    var allEcodmsSaveAttachment = allOpenAttachment.cloneNode(true);
                    allEcodmsSaveAttachment.setAttribute("id","context-ecodms-listsaveattachment");
                    allEcodmsSaveAttachment.setAttribute("command","event.stopPropagation();");
                    allEcodmsSaveAttachment.setAttribute("label",context.extension.localeData.localizeMessage("attachmentsToDms"));
                    allEcodmsSaveAttachment.setAttribute("accesskey","");
                    allEcodmsSaveAttachment.addEventListener("click",doArchiveAllAttachments,false);
                    allAttContext.appendChild(allEcodmsSaveAttachment);
                    console.log("Attachmentlist menu modified.");
                    
                  }
                  else
                  {
                      console.log("Attachmentlist menu already modified.");
                  }
              }
              else
                console.log("Not found.");
              
               var menuAttContext = recentWindow.document.getElementById("attachmentSaveAllSingleMenu");
              if (menuAttContext != null)
              {
         
                  
                  if (recentWindow.document.getElementById("context-ecodms-menulistsaveattachment")==null)
                  {
                  
                    var menuopenAttachment = recentWindow.document.getElementById("button-openAttachment");
                    
                    var menuEcodmsSaveAttachment = menuopenAttachment.cloneNode(true);
                    menuEcodmsSaveAttachment.setAttribute("id","context-ecodms-menulistsaveattachment");
                    menuEcodmsSaveAttachment.setAttribute("oncommand","event.stopPropagation();");
                    menuEcodmsSaveAttachment.setAttribute("label",context.extension.localeData.localizeMessage("attachmentToDms"));
                    menuEcodmsSaveAttachment.setAttribute("accesskey","");
                    menuEcodmsSaveAttachment.addEventListener("click",doArchiveAttachment,false);
                    
                    menuAttContext.appendChild(menuEcodmsSaveAttachment);
                    console.log("MenuAttachmentlist menu modified.");
                    
                  }
                  else
                  {
                      console.log("MenuAttachmentlist menu already modified.");
                  }
              }
              else
                console.log("Not found.");
              
              
              var menuallAttContext = recentWindow.document.getElementById("attachmentSaveAllMultipleMenu");
              if (menuallAttContext != null)
              {
         
                  
                  if (recentWindow.document.getElementById("context-ecodms-menulistsaveallattachment")==null)
                  {
                  
                    var maneuallopenAttachment = recentWindow.document.getElementById("button-openAllAttachments");
                    
                    var menuallEcodmsSaveAttachment = maneuallopenAttachment.cloneNode(true);
                    menuallEcodmsSaveAttachment.setAttribute("id","context-ecodms-menulistsaveallattachment");
                    menuallEcodmsSaveAttachment.setAttribute("oncommand","event.stopPropagation();");
                    menuallEcodmsSaveAttachment.setAttribute("label",context.extension.localeData.localizeMessage("attachmentsToDms"));
                    menuallEcodmsSaveAttachment.setAttribute("accesskey","");
                    menuallEcodmsSaveAttachment.addEventListener("click",doArchiveAllAttachments,false);
                    menuallAttContext.appendChild(menuallEcodmsSaveAttachment);
                    console.log("MenuAllAttachmentlist menu modified.");
                    
                  }
                  else
                  {
                      console.log("MenuAllAttachmentlist menu already modified.");
                  }
              }
              else
                console.log("Not found.");
              
   
          }
          
		  //let recentWindow = Services.wm.getMostRecentWindow("mail:3pane");
          //if (recentWindow) {
          //  recentWindow.MsgSearchMessages();
          //}
    
};

function myComposeListener()
{
    
}

function getMsgFolderFromUri(uri, checkFolderAttributes) 
{
     var myWindow = Services.wm.getMostRecentWindow("msgcompose");
    if (typeof MailUtils !== 'undefined' && MailUtils.getFolderForURI) {
      return MailUtils.getFolderForURI(uri, checkFolderAttributes);
    }
    else if (typeof MailUtils !== 'undefined' && MailUtils.getExistingFolder)
    {
        return MailUtils.getExistingFolder(uri, checkFolderAttributes);
    }
    else
        throw Exception("Unable to get Msg-Folder");
};

myComposeListener.prototype =
{
       isWorkaround: false,
       saveIsDone: false,
       NotifyComposeFieldsReady: function(){

           
       },
       ComposeProcessDone: function(aResult)
       {
            console.log("Compose process done");
            var myWindow = Services.wm.getMostRecentWindow("msgcompose");
                
            try
            {
                var gMsgCompose = myWindow.gMsgCompose;
                
                if (aResult===Components.results.NS_OK)
                {
                    if (gMsgCompose.messageSend.messageKey===4294967295)
                    {
                        this.isWorkaround=true;
                        SaveAsDraft();
                       
                       var threadManager = Components.classes["@mozilla.org/thread-manager;1"]
                         .getService(Components.interfaces.nsIThreadManager);
                       
                        var thread=threadManager.mainThread;
                        var thread2=threadManager.currentThread;
                        while(!saveIsDone)
                        {
                           thread.processNextEvent(1000);
                           thread2.processNextEvent(1000);
                        }
                       
                      
                        
                     
                    }
                    else
                    {
                     
                      var folder=gMsgCompose.savedFolderURI;
                      var theFolder=getMsgFolderFromUri(folder,false);
                      var msgKey=gMsgCompose.messageSend.messageKey;
                      var msgURIX = theFolder.generateMessageURI(msgKey);
                      var msgUris = new Array(msgURIX);
                      isSendMail=true;
                      ecoDMS_onArchiveCommandWithSubject(msgUris,gMsgCompose.compFields.subject);
                      this.unregister();
                      if (this.isWorkaround)
                      {
                       
                        var msgs = Components.classes["@mozilla.org/array;1"].createInstance(Components.interfaces.nsIMutableArray);
                        msgs.appendElement(theFolder.GetMessageHeader(msgKey),false);
                        theFolder.deleteMessages(msgs,null,true,false,null,false);
                        
                      }
                      this.saveIsDone=true;
                  }
              
               }       
               else
                   this.unregister();
               
               
            }
            catch (e)
            {
                myWindow.alert('Cannot send e-mail to archive! '+e);
            }
       },
       SaveInFolderDone: function(folderURI){
         
       },
       register: function()
       {
          var myWindow = Services.wm.getMostRecentWindow("msgcompose");
          myWindow.gMsgCompose.RegisterStateListener(this);
          console.log("Listener added");
       },
       unregister: function()
       {
          var myWindow = Services.wm.getMostRecentWindow("msgcompose");
          myWindow.gMsgCompose.UnregisterStateListener(this);
       }
       
};

var listener = {
        
     mycallback: null,
     sendNotification: function(cmd,state)
     {
         return mycallback(cmd,state);
     },
     add: function(callback) {
        console.log("Callback added.");
        mycallback = callback;
     },
     remove: function(callback)
     {
        console.log("Callback removed.");
     }
    
};


ecodmsapi = class extends ExtensionCommon.ExtensionAPI {
    
     onStartup() {
            console.log("Do startup!");
            const aomStartup = Cc["@mozilla.org/addons/addon-manager-startup;1"].getService(Ci.amIAddonManagerStartup);
            const manifestURI = Services.io.newURI("manifest.json", null, this.extension.rootURI);
            this.chromeHandle = aomStartup.registerChrome(manifestURI, [
                        ["content", "ecodms", "content/"]
            ]);
     }
     
    onShutdown(isAppShutdown) {
        console.log("Do shutdown.");
        if (isAppShutdown) return;

        ecoDMS_removeAttachmentContextMenus();
        
        Services.obs.notifyObservers(null, "startupcache-invalidate");
        this.chromeHandle.destruct();
        this.chromeHandle = null;
        console.log("implementation.js: ecoDMS Addon shutdown");
    }
     
    getAPI(context) {
        
        ecoDMS_checkAttachmentContextMenus(context);
        
        return {
            ecodmsapi: {
          ecoDMS_doArchive(msgIds)
          {
			  let msgId=0;
			  uris = new Array();
			  for (var i=0;i<msgIds.length;i++)
			  {
				  let realMessage = context.extension.messageManager.get(msgIds[i]);
				  uris[i]=realMessage.folder.getUriForMsg(realMessage);
			  }
			  
              if (uris!=null && uris[0]!=null)
			  {
                ecoDMS_doArchive(msgId);
			  }

          },
        log(msg) {
          console.log(msg);
        },
        ecoDMS_checkAttachmentContextMenus() {
            ecoDMS_checkAttachmentContextMenus(context);
        },
        ecoDMS_doSendAndArchive() {
            console.log("Register compose listener");
            var myWindow = Services.wm.getMostRecentWindow("msgcompose");
            composeListener = new myComposeListener();
            composeListener.register();
            myWindow.goDoCommand("cmd_sendButton");
        },
        registerSendStateObserver() {
            
            var myWindow = Services.wm.getMostRecentWindow("msgcompose");
            var sbutton = myWindow.document.getElementById("button-send");
            console.log("Got send button");
			listener.sendNotification("sendButtonState",sbutton.disabled);
          
            var observer = new myWindow.MutationObserver(function(mutations) {
                mutations.forEach(function(mutation) 
				{
					if (mutation.attributeName == "disabled")
					{
						listener.sendNotification("sendButtonState",mutation.target.disabled);
					}
				});    
          });
 
            // Konfiguration des Observers: alles melden - Änderungen an Daten, Kindelementen und Attributen
            var config = { attributes: true, childList: true, characterData: true };
            // eigentliche Observierung starten und Zielnode und Konfiguration übergeben
            observer.observe(sbutton, config);
            
        },
        onCommand: new ExtensionCommon.EventManager({
          context,
          name: "myapi.onCommand",
          register(fire) 
          {
            function callback(cmd, state) {
              return fire.async(cmd, state);
          }

          listener.add(callback);
          return function() {
              listener.remove(callback);
           };
          },
        }).api(),
      },
    };
  }
  
  
};

function ecoDMS_doArchiveAttachment(attachmentId,archiveAll)
{
    let recentWindow = Services.wm.getMostRecentWindow("mail:3pane");
    let document = recentWindow.document;
    let messenger = recentWindow.messenger;
    
    var executable = Components.classes["@mozilla.org/file/local;1"]
                                     .createInstance(Components.interfaces.nsIFile);
    var process = Components.classes["@mozilla.org/process/util;1"]
                                        .createInstance(Components.interfaces.nsIProcess);
    var printcomworkerpath = ecoDMS_getWorkerPath();

    if (printcomworkerpath==null)
    {
           alert('Die E-Mail kann nicht archiviert werden, installieren sie den ecoDMS Printer!');
           return;
    }
    
    var attachmentList = document.getElementById('attachmentList');
    var selectedAttachments;

    if (archiveAll || attachmentList.selectedItems.length==0)
        selectedAttachments = attachmentList.childNodes;
    else
        selectedAttachments = attachmentList.selectedItems;

    if (attachmentId>=selectedAttachments.length)
    {
        return;
    }

    Components.utils.import("resource://gre/modules/FileUtils.jsm");

    var attachment = selectedAttachments[attachmentId].attachment;
    var fileTemplate;
    if (printcomworkerpath=="/opt/ecodms/ecodmsclient/printcomworker" || printcomworkerpath=="/Applications/ecoDMS Client.app/Contents/MacOS/printcomworker")
         fileTemplate = recentWindow.validateFileName(unescape(encodeURIComponent(attachment.name)));
    else
         fileTemplate = recentWindow.validateFileName(attachment.name);
    var attachmentFile = FileUtils.getFile("TmpD",[fileTemplate]);
    attachmentFile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, FileUtils.PERMS_FILE);

    messenger.saveAttachmentToFile(attachmentFile,attachment.url,attachment.uri,attachment.contentType,
          {
              OnStartRunningUrl: function (url) {
                  attachment_extracted = false;
              },
              OnStopRunningUrl: function(url, code) 
              {
                    
                    if (printcomworkerpath=="/opt/ecodms/ecodmsclient/printcomworker")
                    {
                        var env = Components.classes["@mozilla.org/process/environment;1"]
                                        .getService(Components.interfaces.nsIEnvironment);
                        env.set("LD_LIBRARY_PATH","/opt/ecodms/ecodmsclient/");
                    }
                    executable.initWithPath(printcomworkerpath);
                    process.init(executable);

                    var args;
                    if (printcomworkerpath=="/opt/ecodms/ecodmsclient/printcomworker" || printcomworkerpath=="/Applications/ecoDMS Client.app/Contents/MacOS/printcomworker")
                        args = new Array("-f",unescape(encodeURIComponent(attachmentFile.path)),"-cl","-pn","0##"+unescape(encodeURIComponent(attachment.name))+"#");
                    else
                    {
                        args = new Array("-f",attachmentFile.path,"-cl","-pn","0##"+unescape(encodeURIComponent(attachment.name))+"#");
                    }

                    process.runAsync(args,5,function(subject,topic,data){
                        attachmentFile.remove(true);
                        attachmentFile=null;
                        attachmentId++;
                        ecoDMS_doArchiveAttachment(attachmentId,archiveAll);
                    });

                    
              }
          });

};

